/// <reference types="node" />
import { ClientRequest, IncomingMessage, ServerResponse } from 'http';
import { InstrumentationIfc } from './hooksIfc';
export declare type HookOptions = {
    beforeHook?: Function;
    afterHook?: Function;
};
export declare const isValidHttpRequestBody: (reqBody: any) => boolean;
export declare const isEncodingType: (encodingType: any) => boolean;
export declare const extractBodyFromEmitSocketEvent: (socketEventArgs: any) => any;
export declare const isEmptyString: (str: any) => boolean;
export declare const extractBodyFromWriteOrEndFunc: (writeEventArgs: any) => any;
export declare type HttpRequest = {
    host?: string;
    body?: string;
    path?: string;
    headers?: Record<string, string>;
};
export declare type HttpResponse = {
    statusCode?: number;
    body?: string;
    headers?: Record<string, string>;
};
export declare type RequestData = {
    request: HttpRequest;
    response: HttpResponse;
};
export declare const HttpHooks: InstrumentationIfc<ClientRequest | IncomingMessage, IncomingMessage | ServerResponse>;
//# sourceMappingURL=http.d.ts.map