"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeDuplicates = exports.md5Hash = exports.parseQueryParams = exports.isAwsService = exports.safeGet = exports.runOneTimeWrapper = exports.safeExecute = void 0;
const crypto = __importStar(require("crypto"));
const jsonSortify_1 = require("./tools/jsonSortify");
('["secretsmanager.*.amazonaws.com", "ssm.*.amazonaws.com", "kms.*.amazonaws.com", "sts..*amazonaws.com"]');
function safeExecute(callback, message = 'Error in Lumigo tracer', logLevel = 'warn', defaultReturn = undefined) {
    return function (...args) {
        try {
            return callback.apply(this, args);
        }
        catch (err) {
            console[logLevel](message, err);
            return defaultReturn;
        }
    };
}
exports.safeExecute = safeExecute;
const runOneTimeWrapper = (func, context = undefined) => {
    let done = false;
    return (...args) => {
        if (!done) {
            const result = func.apply(context || this, args);
            done = true;
            return result;
        }
    };
};
exports.runOneTimeWrapper = runOneTimeWrapper;
const safeGet = (obj, arr, dflt = null) => {
    let current = obj;
    for (const i in arr) {
        if (!current) {
            return dflt;
        }
        current = current[arr[i]];
    }
    return current || dflt;
};
exports.safeGet = safeGet;
const isAwsService = (host, responseData = undefined) => {
    if (host && host.includes('amazonaws.com')) {
        return true;
    }
    return !!(responseData &&
        responseData.headers &&
        (responseData.headers['x-amzn-requestid'] || responseData.headers['x-amz-request-id']));
};
exports.isAwsService = isAwsService;
const parseQueryParams = (queryParams) => {
    return safeExecute(() => {
        if (typeof queryParams !== 'string')
            return {};
        const obj = {};
        queryParams.replace(/([^=&]+)=([^&]*)/g, 
        // @ts-ignore
        safeExecute((m, key, value) => {
            obj[decodeURIComponent(key)] = decodeURIComponent(value);
        }, 'Failed to parse a specific key in parseQueryParams'));
        return obj;
    }, 'Failed to parse query params')();
};
exports.parseQueryParams = parseQueryParams;
// eslint-disable-next-line no-unused-vars
const recursiveGetKeyByDepth = (event, keyToSearch, maxDepth) => {
    if (maxDepth === 0) {
        return undefined;
    }
    let foundValue = undefined;
    const examineKey = (k) => {
        if (k === keyToSearch) {
            foundValue = event[k];
            return true;
        }
        if (event[k] && typeof event[k] === 'object') {
            foundValue = recursiveGetKeyByDepth(event[k], keyToSearch, maxDepth - 1);
            return foundValue !== undefined;
        }
    };
    Object.keys(event).some(examineKey);
    return foundValue;
};
const md5Hash = (item) => {
    try {
        const md5sum = crypto.createHash('md5');
        md5sum.update((0, jsonSortify_1.sortify)(item));
        return md5sum.digest('hex');
    }
    catch (err) {
        console.warn('Failed to hash item', err);
        return undefined;
    }
};
exports.md5Hash = md5Hash;
// @ts-ignore
const removeDuplicates = (arr) => Array.from(new Set(arr));
exports.removeDuplicates = removeDuplicates;
//# sourceMappingURL=utils.js.map